"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const collection2 = require("./collection2.js");
const collectionItem = require("./collection-item.js");
const Vue = require("vue");
const COLLECTION_ITEM_SIGN = `data-el-collection-item`;
const createCollectionWithScope = (name) => {
  const COLLECTION_NAME = `El${name}Collection`;
  const COLLECTION_ITEM_NAME = `${COLLECTION_NAME}Item`;
  const COLLECTION_INJECTION_KEY = Symbol(COLLECTION_NAME);
  const COLLECTION_ITEM_INJECTION_KEY = Symbol(COLLECTION_ITEM_NAME);
  return {
    COLLECTION_INJECTION_KEY,
    COLLECTION_ITEM_INJECTION_KEY,
    ElCollection: Object.assign({}, collection2.default, {
      name: COLLECTION_NAME,
      setup() {
        const collectionRef = Vue.ref();
        const itemMap = /* @__PURE__ */ new Map();
        const getItems = () => {
          const collectionEl = Vue.unref(collectionRef);
          if (!collectionEl) return [];
          const orderedNodes = Array.from(collectionEl.querySelectorAll(`[${COLLECTION_ITEM_SIGN}]`));
          return [...itemMap.values()].sort((a, b) => orderedNodes.indexOf(a.ref) - orderedNodes.indexOf(b.ref));
        };
        Vue.provide(COLLECTION_INJECTION_KEY, {
          itemMap,
          getItems,
          collectionRef
        });
      }
    }),
    ElCollectionItem: Object.assign({}, collectionItem.default, {
      name: COLLECTION_ITEM_NAME,
      setup(_, { attrs }) {
        const collectionItemRef = Vue.ref();
        const collectionInjection = Vue.inject(COLLECTION_INJECTION_KEY, void 0);
        Vue.provide(COLLECTION_ITEM_INJECTION_KEY, { collectionItemRef });
        Vue.onMounted(() => {
          const collectionItemEl = Vue.unref(collectionItemRef);
          if (collectionItemEl) collectionInjection.itemMap.set(collectionItemEl, {
            ref: collectionItemEl,
            ...attrs
          });
        });
        Vue.onBeforeUnmount(() => {
          const collectionItemEl = Vue.unref(collectionItemRef);
          collectionInjection.itemMap.delete(collectionItemEl);
        });
      }
    })
  };
};
exports.COLLECTION_ITEM_SIGN = COLLECTION_ITEM_SIGN;
exports.createCollectionWithScope = createCollectionWithScope;
